import * as mc from "@minecraft/server";
import * as ItemComponent from "./wg/items.js";
import * as Jutsu from "./wg/jutsus.js";
import "./wg/attack.js";
import { title, menu, projetil, entities, camera, searchMob } from "./wg/commands.js";
import { getScore, removeScore } from "./wg/all.js";
import "./wg/events.js";
import "./wg/mission.js";
import "./wg/spawn.js";
import "./wg/stats.js";
import "./wg/structures.js";

mc.world.beforeEvents.worldInitialize.subscribe(event => {
	const itemComponentRegistry = event.itemComponentRegistry;
	const blockComponentRegistry = event.blockComponentRegistry;
	
	itemComponentRegistry.registerCustomComponent("wesl3y:menu",{onUse: arg => {ItemComponent.menu(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:menu_uchiha",{onUse: arg => {ItemComponent.menu_uchiha(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:menu_hyuga",{onUse: arg => {ItemComponent.menu_hyuga(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:menu_modes",{onUse: arg => {ItemComponent.menu_modes(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:kunai",{onUse: arg => {ItemComponent.kunai(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:chakra_pill",{onConsume: arg => {ItemComponent.chakra_pill(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:ramen",{onConsume: arg => {ItemComponent.ramen(arg.source);}});
	
	itemComponentRegistry.registerCustomComponent("wesl3y:byakugan_trigramas",{onUse: arg => {Jutsu.useJutsus(arg.source, "byakugan_trigramas", 1000);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:byakugan_vacuum_palm",{onUse: arg => {Jutsu.useJutsus(arg.source, "byakugan_vacuum_palm", 700);}});
	
	itemComponentRegistry.registerCustomComponent("wesl3y:sharingan_genjutsu",{onUse: arg => {Jutsu.useJutsus(arg.source, "sharingan_genjutsu", 50);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:sharingan_izanagi",{onUse: arg => {Jutsu.useJutsus(arg.source, "sharingan_izanagi", 600);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:mangekyou_susanoo",{onUse: arg => {Jutsu.susanoo1(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:mangekyou_amaterasu",{onUse: arg => {Jutsu.useJutsus(arg.source, "mangekyou_amaterasu", 5000);}});

	itemComponentRegistry.registerCustomComponent("wesl3y:rasengan",{onUse: arg => {Jutsu.useJutsus(arg.source, "rasengan", 500);}});
	
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_fire_ball",{onUse: arg => {Jutsu.useJutsus(arg.source, "fire_ball", 200);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_phoenix_flower",{onUse: arg => {Jutsu.useJutsus(arg.source, "phoenix_flower", 350);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_explosive_clone",{onUse: arg => {Jutsu.useJutsus(arg.source, "explosive_clone", 500);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_fire_dragon",{onUse: arg => {Jutsu.useJutsus(arg.source, "fire_dragon", 700);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_earth_spears",{onUse: arg => {Jutsu.useJutsus(arg.source, "earth_spears", 400);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_earth_golem",{onUse: arg => {Jutsu.useJutsus(arg.source, "earth_golem", 350);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_earth_wall",{onUse: arg => {Jutsu.useJutsus(arg.source, "earth_wall", 300);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_underworld_swamp",{onUse: arg => {Jutsu.useJutsus(arg.source, "underworld_swamp", 1300);}});
	
	

	blockComponentRegistry.registerCustomComponent("wesl3y:doton_despawn_tick",{onTick: arg => {ItemComponent.doton_despawn_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:hyoton.ice.tick",{onTick: arg => {ItemComponent.hyoton_ice_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:konoha_tick",{onTick: arg => {ItemComponent.konoha_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:mud_despawn_tick",{onTick: arg => {ItemComponent.mud_despawn_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:itachi_tick_block",{onTick: arg => {ItemComponent.itachi_tick_block(arg.block,arg.player,arg.permutationToPlace);}});
1});

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    title(player)
    menu(player);
    player.nameTag = `${player.name}\nHp: §e${Math.floor(player.getComponent("health")?.currentValue)}§f`;
  }
});

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    if (getScore("time.Susan", player) >= 1) {
      removeScore(player, "time.Susan", 1);
      if (getScore("time.Susan", player) == 1 && player.getProperty('wesl3y:mode_chest') == 13) {
        player.triggerEvent("wesl3y:reset_chest");
        player.runCommandAsync(`effect @s wither 10 2 true`);
        player.runCommandAsync(`effect @s blindness 7 2 true`);
        player.runCommandAsync(`effect @s weakness 7 2 true`);
      }
    }
  }
}, 20);


mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    for (const entity of mc.world.getDimension("overworld").getEntities()) {
      camera(entity, player);
      entities(entity);
      projetil(entity, player);
      searchMob(entity, player);
    }
  }
});
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                                                                                                                      
                                      
                                      
                                      
                                      
                                                                                                                                                                                                   
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                                                                                                                      
                                      
                                      
                                      
                                      
                                                                                                                                                                                                                                                             