import * as mc from '@minecraft/server';
import { getScore, hasEquipmentItem, ItemDurability } from './all.js';
import { stats_menu, npc_guy, npc_ichiraku, npc_kakashi, npc_iruka0, npc_iruka, npc_shinobi, npc_tenten, npc_tsunade, npc_velha } from './menu.js';
import * as list from './list.js';
import * as q from './list.js';

export function getDistance(playerLocationA, playerLocationB) {
  const { x: x1, y: y1, z: z1 } = playerLocationA;
  const { x: x2, y: y2, z: z2 } = playerLocationB;
  const distance = Math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2 + (z2 - z1) ** 2);
  return Math.floor(distance);
}

export async function camera(entity, player) {
  if (player.hasTag("sidifjcjcufjdjdjdj")) {
    player.runCommandAsync("inputpermission set @s movement disabled");
  }
}

let search = 0;

export function searchMob(entity, player) {
  const mission = q.Missions.list[getScore("missions", player)];
  if (mission.coords == null) return;
  const distance = getDistance(player.location, {x: mission.coords[0], y: Math.floor(player.location.y), z: mission.coords[2]});
  search = `Target: ${distance}m`
}

export function projetil(entity, player) {
  if (entity.typeId != "wesl3y:jutsu_attack" && entity.typeId != "wesl3y:jutsu_projetil") return;
  const
    jutsuName = entity.getProperty("wesl3y:jutsu"),
    teste = jutsuName ? list.JutsuEntities[jutsuName] : null,
    damage = Math.floor(teste.damage + (0.25 * getScore("jutsu_stats", player))),
    name = entity.nameTag;
  if (teste.damage) entity.runCommandAsync(`damage @e[r=${teste.range},name=!"${name}",family=!attack,family=!inanimate,type=!item,type=!xp_orb] ${damage} projectile entity @e[name="${name}",type=!wesl3y:jutsu_attack,type=!wesl3y:jutsu_projetil,c=1]`);
  if (teste.knock) entity.runCommandAsync(`execute as @e[r=0.5,name=!"${name}",family=!attack,family=!inanimate,type=!item,type=!xp_orb] run scriptevent wg:knock`);
}

export function entities(entity) {
  switch (entity.typeId) {
    case `wesl3y:gaara_classic`:
      entity.nameTag = `Gaara [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:haku`:
      entity.nameTag = `Haku [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:itachi_classic`:
      entity.nameTag = `Itachi [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:mission.anbu`:
      entity.nameTag = `Anbu\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:mission.bandit`:
      entity.nameTag = `Bandit\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:mission.iruka_clone`:
      entity.nameTag = `Iruka Bunshin\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:mizuki`:
      entity.nameTag = `Mizuki\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:sasuke_classic`:
      entity.nameTag = `Sasuke [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:shinobi.konoha`:
      entity.nameTag = `Shinobi Konoha\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:zabuza`:
      entity.nameTag = `Zabuza [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
  }
}

export function title(player) {
  if (player.hasTag("Inv.manda") || player.hasTag("Chk.rasengan") || player.hasTag("Rai.chidori")) return;
  const
    mission = list.Missions.list[getScore("missions", player)],
    hpCur = Math.floor(player.getComponent("health")?.currentValue),
    hpMax = Math.floor(player.getComponent("health")?.effectiveMax),
    chkCur = Math.floor(getScore('chakra', player)),
    chkMax = Math.floor(getScore('chakraMax', player)),//100 + 20 * getScore("chakra_stats", player),
    expCur = Math.floor(getScore('exp', player)),
    expMax = Math.floor(getScore('expMax', player)),
    lvlCur = Math.floor(getScore('level', player)),
    moneyCur = Math.floor(getScore('money', player)),
    hp = Math.floor(player.getComponent("health")?.currentValue * 10 / hpMax),
    chk = Math.floor(getScore('chakra', player) * 10 / chkMax),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("senju") ? "Senju" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("uzumaki") ? "Uzumaki" : null,
    choose = getScore("choose_mode", player),
    clan_item = hasEquipmentItem(player, "Mainhand", "wesl3y:menu_hyuga") ? "Hyuga" : hasEquipmentItem(player, "Mainhand", "wesl3y:menu_uchiha") ? "Uchiha" : hasEquipmentItem(player, "Mainhand", "wesl3y:menu_modes") ? "Modes" : null,
    curse_mark = player.hasTag("curse_mark1") ? " 1" : player.hasTag("curse_mark2") ? " 2" : "",
    gates = player.getProperty('wesl3y:mode_chest') == 3 ? " 1" : player.getProperty('wesl3y:mode_chest') == 4 ? " 2" : player.getProperty('wesl3y:mode_chest') == 5 ? " 3" : player.getProperty('wesl3y:mode_chest') == 6 ? " 4" : player.getProperty('wesl3y:mode_chest') == 7 ? " 5" : player.getProperty('wesl3y:mode_chest') == 8 ? " 6" : player.getProperty('wesl3y:mode_chest') == 9 ? " 7" : player.getProperty('wesl3y:mode_chest') == 10 ? " 8" : "",
    sennin = player.hasTag("sennin_frogs") ? " Frogs" : player.hasTag("sennin_snakes") ? " Snakes" : "",
    kurama = player.hasTag("kurama1") ? " 1" : player.hasTag("kurama2") ? " 2" : player.hasTag("kurama3") ? " 3" : "";
  let bar = " ";
  switch (clan_item) {
    case `Hyuga`:
      bar = `§b>§7Byakugan§b<`;
    break
    case `Uchiha`:
      bar = `${choose == 0 ? "§b>§cSharingan§b<\n§7Mangekyou" : "§7Sharingan\n§b>§cMangekyou§b<§f"}`;
    break
    case `Modes`:
      bar = `${choose == 0 ? "§b>§aCurse Mark" + curse_mark + "§b<\n§7Eight Gates§f" : choose == 1 ? "§b>§aEight Gates" + gates + "§b<\n§7Sennin§f" : choose == 2 ? "§b>§aSennin" + sennin + "§b<\n§7Kurama§f" : "§b>§aKurama" + kurama + "§b<\n§7Curse Mark§f"}`;
    break
  }
  player.onScreenDisplay.setActionBar(`${bar}\n${player.hasTag("in_mission") && mission.coords != null ? search : ""}`);
  player.onScreenDisplay.setTitle(`          §l${hpCur}/${hpMax}§r\n          §l${chkCur}§r\n        §l§eExp: §f${expCur}/${expMax}§r\n§l§eLevel: §f${lvlCur}§r\n§l§eRyu: §f${moneyCur}\n§l§eClan: §f${clan}\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n[health${hp}]\n[chakra${chk}]\n[clan_${clan}]`);
}


export function menu(player) {
  const tags = player.hasTag("stats_menu") ? "stats_menu" : player.hasTag("npc_guy") ? "guy" : player.hasTag("npc_iruka") ? "iruka" : player.hasTag("npc_ichiraku") ? "ichiraku" : player.hasTag("npc_iruka") ? "iruka" : player.hasTag("npc_kakashi") ? "kakashi" : player.hasTag("npc_shinobi") ? "shinobi" : player.hasTag("npc_tsunade") ? "tsunade" : player.hasTag("npc_tenten") ? "tenten" : player.hasTag("npc_velha") ? "velha" : null;
  switch (tags) {
    case `stats_menu`:
      stats_menu(player);
      player.removeTag("stats_menu");
    break;
    case `guy`:
      npc_guy(player);
      player.removeTag("npc_guy");
    break;
    case `ichiraku`:
      npc_ichiraku(player);
      player.removeTag("npc_ichiraku");
    break;
    case `iruka`:
      if (player.hasTag("gennin")) npc_iruka(player);
      if (!player.hasTag("gennin")) npc_iruka0(player);
      player.removeTag("npc_iruka");
    break;
    case `kakashi`:
      npc_kakashi(player);
      player.removeTag("npc_kakashi");
    break;
    case `shinobi`:
      npc_shinobi(player);
      player.removeTag("npc_shinobi");
    break;
    case `tsunade`:
      npc_tsunade(player);
      player.removeTag("npc_tsunade");
    break;
    case `tenten`:
      npc_tenten(player);
      player.removeTag("npc_tenten");
    break;
    case `velha`:
      npc_velha(player);
      player.removeTag("npc_velha");
    break;
  }
}

                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               