import * as mc from "@minecraft/server";
import { setScore } from './all.js';

mc.system.afterEvents.scriptEventReceive.subscribe(event => {
  const wg = event.id.split("wg:")[1];
  const eventEntity = event.sourceEntity;;
  if (wg == "dash") {
    dash(eventEntity);
  }
  else if (wg == "back_flip") {
    back_flip(eventEntity);
  }
  else if (wg == "knock_side") {
    knock_side(eventEntity);
  }
  else if (wg == "clone") {
    clone(eventEntity);
  }
  else if (wg == "entityName") {
    entityName(eventEntity);
  }
  else if (wg == "knock") {
    knock(eventEntity);
  }
  else if (wg == "test") {
    test2(eventEntity);
  }
});

export function test2(eventEntity) {
  mc.world.setDynamicProperty("wesl3y:itachi", 0);
}
    
export function back_flip(eventEntity) {
  const view = eventEntity.getViewDirection();
  eventEntity.applyKnockback(-view.x, -view.z, 4, 0.3);
  eventEntity.runCommandAsync('playanimation @s animation.ninja.back_flip wesl3y');
  eventEntity.runCommandAsync('playsound dash @a ~~~ 1.5');
}
    
export function knock_side(eventEntity) {
  const view = eventEntity.getViewDirection();
  eventEntity.applyKnockback(-view.x, view.z, 3, 0.5);
  eventEntity.runCommandAsync('playanimation @s animation.ninja.back_flip wesl3y');
  eventEntity.runCommandAsync('playsound dash @a ~~~ 1.5');
}

export function clone(eventEntity) {
  const
    head = eventEntity.getComponent('equippable').getEquipment('Head'),
    chest = eventEntity.getComponent('equippable').getEquipment('Chest'),
    legs = eventEntity.getComponent('equippable').getEquipment('Legs'),
    feet = eventEntity.getComponent('equippable').getEquipment('Feet');
  eventEntity.runCommand(`event entity @e[family=bunshin,name="${eventEntity.nameTag}"] wesl3y:clan.${eventEntity.getProperty("wesl3y:clan")}`);
  eventEntity.runCommand(`event entity @e[family=bunshin,name="${eventEntity.nameTag}"] wesl3y:skin.${eventEntity.getProperty("wesl3y:skin")}`);
  eventEntity.runCommand(`event entity @e[family=bunshin,name="${eventEntity.nameTag}"] wesl3y:hair.${eventEntity.getProperty("wesl3y:hair")}`);
  eventEntity.runCommand(`replaceitem entity @e[family=bunshin,name="${eventEntity.nameTag}"] slot.armor.head 0 ${head ? head?.typeId : "air"}`);
  eventEntity.runCommand(`replaceitem entity @e[family=bunshin,name="${eventEntity.nameTag}"] slot.armor.chest 0 ${chest ? chest?.typeId : "air"}`);
  eventEntity.runCommand(`replaceitem entity @e[family=bunshin,name="${eventEntity.nameTag}"] slot.armor.legs 0 ${legs ? legs?.typeId : "air"}`);
  eventEntity.runCommand(`replaceitem entity @e[family=bunshin,name="${eventEntity.nameTag}"] slot.armor.feet 0 ${feet ? feet?.typeId : "air"}`);
}

export function command(eventEntity, timer, command, command2) {
  let time = 0;
  const timming = mc.system.runInterval(() => {
    time = time + 1
    if (time >= timer || eventEntity.getComponent('minecraft:health')?.currentValue <= 0) {
      eventEntity.runCommandAsync(command);
      if (command2 != null) {
        eventEntity.runCommandAsync(command2);
      }
      mc.system.clearRun(timming);
    }
  }, 20);
}

export function dash(eventEntity) {
  let
    velo = eventEntity.getVelocity(),
    rot = eventEntity.getRotation();
  let rot_math = Math.floor((Math.atan2(velo.z, velo.x) * 180 / Math.PI - 90));
  if (rot_math < -180) { rot_math = rot_math + 360; }
  let rot_calc = Math.abs(rot_math - Math.floor((rot.y)));
  rot_calc = Math.min(rot_calc, (360-rot_calc));
  let
    daash1 = (rot_calc > 120) ? "animation.ninja.back_flip" : "animation.ninja.jump"
  const
    z = (rot.z + 90)* Math.PI/180,
    x = (rot.x + 90)* Math.PI/180,
    y = (rot.y + 90)* Math.PI/180;
  if (!eventEntity.isSprinting) {
    eventEntity.applyKnockback(velo.x, velo.z, rot_calc > 120 ? 3 : 0, rot_calc > 120 ? 0.2 : 1);
    eventEntity.playAnimation(daash1);
    eventEntity.runCommandAsync('playsound dash @a ~~~ 1.5');
  } else {
    eventEntity.applyKnockback(velo.x, velo.z, 3, 0.2);
    eventEntity.playAnimation("animation.ninja.dash");
    eventEntity.runCommandAsync('playsound dash @a ~~~ 1.5');
  }
}

export function dash_2(eventEntity) {
  let
    velo = eventEntity.getVelocity(),
    rot = eventEntity.getRotation(),
    Knckz = velo.z > 0.1 ? 3: 0,
    Kncky = velo.y > 0.1 ? 0.2 : 1;
  let rot_math = Math.floor((Math.atan2(velo.z, velo.x) * 180 / Math.PI - 90));
  if (rot_math < -180) { rot_math = rot_math + 360; }
  let rot_calc = Math.abs(rot_math - Math.floor((rot.y)));
  rot_calc = Math.min(rot_calc, (360-rot_calc));
  let daash1 = (rot_calc > 120) ? "animation.ninja.back_flip" : "animation.ninja.jump";
  const
    z = (rot.z + 90)* Math.PI/180,
    x = (rot.x + 90)* Math.PI/180,
    y = (rot.y + 90)* Math.PI/180;
  if (!eventEntity.isSprinting) {
    eventEntity.applyKnockback(velo.x, velo.z, Knckz, Kncky);
    eventEntity.playAnimation(daash1);
    eventEntity.runCommandAsync('playsound dash @a ~~~ 1.5');
  } else {
    eventEntity.applyKnockback(velo.x, velo.z, 3, 0.2);
    eventEntity.playAnimation("animation.ninja.dash");
    eventEntity.runCommandAsync('playsound dash @a ~~~ 1.5');
  }
}

export function entityName(entity) {
  switch (entity.typeId) {
    case `wesl3y:npc_guy`:
      entity.nameTag = `§aGuy [§9Npc§a]§f`;
    break
    case `wesl3y:npc_ichiraku`:
      entity.nameTag = `§aIchiraku [§9Npc§a]§f`;
    break
    case `wesl3y:npc_iruka`:
      entity.nameTag = `§aIruka [§9Npc§a]§f`;
    break
    case `wesl3y:npc_itachi`:
      entity.nameTag = `§aItachi [§9Npc§a]§f`;
    break
    case `wesl3y:npc_kakashi`:
      entity.nameTag = `§aKakashi [§9Npc§a]§f`;
    break
    case `wesl3y:npc_shinobi`:
      entity.nameTag = `§aShinobi [§9Npc§a]§f`;
    break
    case `wesl3y:npc_tsunade`:
      entity.nameTag = `§aTsunade [§9Npc§a]§f`;
    break
    case `wesl3y:npc_velha`:
      entity.nameTag = `§aVelha [§9Npc§a]§f`;
    break
  }
}

export async function knock(entity) {
  const view = entity.getViewDirection();
  entity.runCommand("particle wesl3y:impact_smash ~~1.5~");
  entity.runCommand("particle wesl3y:impact_smash2 ~~1.5~");
  entity.runCommand(`playanimation @s animation.ninja.knock wesl3y`);
  entity.runCommand(`effect @s[type=!player] slowness 4 255 true`);
  entity.runCommand(`inputpermission set @s[type=player] movement disabled`);
  entity.applyKnockback(view.x, view.z, 5, 0.7);
  if (entity.typeId == "minecraft:player") {
  	setScore(entity, "stun", 80);
  }
  await mc.system.waitTicks(80);
  entity.runCommand(`inputpermission set @s[type=player] movement enabled`);
}




function test(eventEntity) {
  eventEntity.applyKnockback(0,0,0,3);
  const entityRaycastHit = eventEntity.getEntitiesFromViewDirection({excludeFamilies:["inanimate"],excludeTypes:["item","xp_orb"]})[0];
  if(entityRaycastHit==undefined) return;
  const target = entityRaycastHit.entity;
  const targetLocation = target.location;
  const targetLocationX = targetLocation.x;
  const targetLocationY = targetLocation.y;
  const targetLocationZ = targetLocation.z;
  const eventEntityLocation = eventEntity.location;
  const eventEntityLocationX = eventEntityLocation.x;
  const eventEntityLocationY = eventEntityLocation.y;
  const eventEntityLocationZ = eventEntityLocation.z;
  const targetDistXZ = Math.sqrt(Math.pow((targetLocationX - eventEntityLocationX),2) + Math.pow((targetLocationZ - eventEntityLocationZ),2));
  const targetDistY = targetLocationY - eventEntityLocationY;
  const targetDist = Math.sqrt(Math.pow(targetDistXZ,2) + Math.pow(targetDistY,2));
  const viewDirection = eventEntity.getViewDirection();
  const horizontalStrength = targetDistXZ / (2 + targetDistXZ*0.02);
  const headRotation = eventEntity.getRotation().x;
  const verticalStrength = targetDistY/2;
  eventEntity.applyKnockback(viewDirection.x,viewDirection.z,horizontalStrength,2);
}


                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                
                  
                          
                
                
                
                
                
                
                
                
                
                                  
                
                
                
                
                
                
                    
                                  
                
                
                
                
                
                
                       
                
                              
                
                
                
                
                
                
                
                
                
                  
                          
                
                
                
                
                
                
                
                
                
                                  
                
                
                
                
                
                
                    
                                  
                
                
                
                
                
                
                       
                
                                                                
                
                                                                                                                 
                
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            