import * as mc from "@minecraft/server";
import { BlockPermutation } from "@minecraft/server";
import { random, getScore } from './all.js';
import { command } from './events.js';
import { clan_wait, custom_menu, stats_menu } from './menu.js';

export function samehada(hitEntity){
	hitEntity.runCommandAsync("scoreboard players remove @s chakra 20");
}

export async function kunai(player){
  player.runCommandAsync(`clear @s wesl3y:kunai 0 1`);
  player.playAnimation("animation.player.shoot_kunai");
  await mc.system.waitTicks(2);
  player.triggerEvent("kunai.projectile")
}

export function menu(player){
  if (player.hasTag("custom")) {
    stats_menu(player);
  } else clan_wait(player, custom_menu);
}

export function menu_hyuga(player) {
  if (getScore("chakra", player) < 100 && player.getProperty('wesl3y:mode_head') == 0) {
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.requires_chakra_100"}]}`);
  }
  else if (player.getProperty('wesl3y:mode_head') != 0) {
    player.triggerEvent("wesl3y:reset_head");
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.doujutsu_desativado"}]}`);
  }
  else if (getScore("chakra", player) >= 100 && player.getProperty('wesl3y:mode_head') == 0) {
    if (getScore("choose_mode", player) == 0) {
      player.runCommand(`tellraw @s[tag=!unlock.bya] {"rawtext":[{"translate":"lock.bya"}]}`);
      player.runCommand(`execute at @s[tag=unlock.bya] run playsound byakugan @a ~~~ 0.25`);
      player.runCommand(`event entity @s[tag=unlock.bya] wesl3y:byakugan`);
    }
  }
}

export function menu_uchiha(player){
  if (getScore("chakra", player) < 100 && player.getProperty('wesl3y:mode_head') == 0) {
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.requires_chakra_100"}]}`);
  }
  else if (player.getProperty('wesl3y:mode_head') != 0) {
    player.triggerEvent("wesl3y:reset_head");
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.doujutsu_desativado"}]}`);
  }
  else if (getScore("chakra", player) >= 100 && player.getProperty('wesl3y:mode_head') == 0) {
    if (getScore("choose_mode", player) == 0) {
      player.runCommand(`tellraw @s[tag=!unlock.sha] {"rawtext":[{"translate":"lock.sha"}]}`);
      player.runCommand(`execute at @s[tag=unlock.sha] run playsound sharingan @a ~~~ 0.25`);
      player.runCommand(`event entity @s[tag=unlock.sha,scores={level=..24}] wesl3y:sharingan`);
      player.runCommand(`event entity @s[tag=unlock.sha,scores={level=25..49}] wesl3y:sharingan2`);
      player.runCommand(`event entity @s[tag=unlock.sha,scores={level=50..}] wesl3y:sharingan3`);
    }
    else {
      player.runCommand(`tellraw @s[tag=!unlock.mang] {\"rawtext\":[{\"translate\":\"lock.mang\"}]}`);
      player.runCommand(`execute at @s[tag=unlock.mang] run playsound sharingan @a ~~~ 0.5`);
      player.runCommand(`event entity @s[tag=unlock.mang] wesl3y:mangekyou`);
    }
  }
}

export function menu_modes(player) {
  if (getScore("chakra", player) < 100 && player.getProperty('wesl3y:mode_chest') == 0) {
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.requires_chakra_100"}]}`);
  }
  else if (getScore("chakra", player) >= 100) {
    if (getScore("choose_mode", player) == 0 && player.getProperty('wesl3y:mode_chest') != 10) {
      if (player.hasTag("unlock.curseM")) {
        if (player.getProperty('wesl3y:mode_chest') == 0) player.triggerEvent("wesl3y:curse_mark");
        if (player.getProperty('wesl3y:mode_chest') == 1 && getScore("level", player) >= 30) player.triggerEvent("wesl3y:curse_mark2");
        if (player.getProperty('wesl3y:mode_chest') == 1 && getScore("level", player) < 30) {
          player.triggerEvent("wesl3y:reset_chest");
          player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`);
        }
        if (player.getProperty('wesl3y:mode_chest') >= 2) {
          player.triggerEvent("wesl3y:reset_chest");
          player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`);
        }
      } else player.runCommand(`tellraw @s {"rawtext":[{"translate":"lock.curseM"}]}`);
    }
    if (getScore("choose_mode", player) == 1 && player.getProperty('wesl3y:mode_chest') != 10) {
      if (player.hasTag("unlock.gates")) {
        if (player.getProperty('wesl3y:mode_chest') == 0) player.triggerEvent("wesl3y:gate1");
        if (player.getProperty('wesl3y:mode_chest') == 3 && getScore("level", player) >= 40) player.triggerEvent("wesl3y:gate2"); else if (player.getProperty('wesl3y:mode_chest') == 3 && getScore("level", player) < 40) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 4 && getScore("level", player) >= 50) player.triggerEvent("wesl3y:gate3"); else if (player.getProperty('wesl3y:mode_chest') == 4 && getScore("level", player) < 50) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 5 && getScore("level", player) >= 60) player.triggerEvent("wesl3y:gate4"); else if (player.getProperty('wesl3y:mode_chest') == 5 && getScore("level", player) < 60) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 6 && getScore("level", player) >= 70) player.triggerEvent("wesl3y:gate5"); else if (player.getProperty('wesl3y:mode_chest') == 6 && getScore("level", player) < 70) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 7 && getScore("level", player) >= 80) player.triggerEvent("wesl3y:gate6"); else if (player.getProperty('wesl3y:mode_chest') == 7 && getScore("level", player) < 80) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 8 && getScore("level", player) >= 90) player.triggerEvent("wesl3y:gate7"); else if (player.getProperty('wesl3y:mode_chest') == 8 && getScore("level", player) < 90) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 9 && getScore("level", player) >= 100) { player.triggerEvent("wesl3y:gate8"); command(player, 180, "kill @s", "scoreboard players remove @s[scores={level=6..}] level 5", "event entity @s wesl3y:reset_chest"); } else if (player.getProperty('wesl3y:mode_chest') == 9 && getScore("level", player) < 100) { player.triggerEvent("wesl3y:reset_chest"); player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`); }
        if (player.getProperty('wesl3y:mode_chest') == 1 || player.getProperty('wesl3y:mode_chest') == 2 || player.getProperty('wesl3y:mode_chest') >= 11) {
          player.triggerEvent("wesl3y:reset_chest");
          player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`);
        }
      } else player.runCommand(`tellraw @s {"rawtext":[{"translate":"lock.gates"}]}`);
    }
    if (getScore("choose_mode", player) == 2 && player.getProperty('wesl3y:mode_chest') != 10) {
      if (player.hasTag("unlock.sennin_frogs")) {
        if (player.getProperty('wesl3y:mode_chest') == 0) player.triggerEvent("wesl3y:sennin_frogs");
        if (player.getProperty('wesl3y:mode_chest') >= 1) {
          player.triggerEvent("wesl3y:reset_chest");
          player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`);
        }
      } else if (player.hasTag("unlock.sennin_snakes")) {
        if (player.getProperty('wesl3y:mode_chest') == 0) player.triggerEvent("wesl3y:sennin_snakes");
        if (player.getProperty('wesl3y:mode_chest') >= 1) {
          player.triggerEvent("wesl3y:reset_chest");
          player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.mode_desativado"}]}`);
        }
      } else player.runCommand(`tellraw @s {"rawtext":[{"translate":"lock.sennin"}]}`);
    }
  }
}

export function block_despawn_tick(block) {
  const
    on = block.permutation.getState("wesl3y:on"),
    {x,y,z} = block.location;
  if (on == "despawn") {
    block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run fill ${x} ${y} ${z} ${x} ${y} ${z} air`);
    block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run particle wesl3y:doton.earth_wall ${x} ${y} ${z}`);
  }
  if (on == "placed") {
    block.setPermutation(BlockPermutation.resolve(block.type.id, {"wesl3y:on":"despawn"}));
  }
}

export function doton_despawn_tick(block) {
  const
    on = block.permutation.getState("wesl3y:on"),
    down = block.permutation.getState("wesl3y:down") == "air" ? "air" : "grass_path",
    {x,y,z} = block.location;
  if (on == "despawn") {
    block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run fill ${x} ${y} ${z} ${x} ${y} ${z} ${down}`);
    block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run particle wesl3y:doton.earth_wall ${x} ${y} ${z}`);
  }
  if (on == "placed") {
    block.setPermutation(BlockPermutation.resolve(block.type.id, {"wesl3y:on":"despawn","wesl3y:down":`${down}`}));
  }
}

export function hyoton_ice_tick(block) {
  const
    {x,y,z} = block.location;
  block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run fill ${x} ${y} ${z} ${x} ${y} ${z} air`);
}

export function konoha_tick(block) {
  const
    {x,y,z} = block.location,
    random_trash = random(1, 100),
    ranX = random(0, 3),
    ranZ = random(2, 14),
    entityPlayer = block.dimension.getEntities({maxDistance:15,location:block.location,type:"minecraft:player"}),
    entityTrash = block.dimension.getEntities({maxDistance:15,location:block.location,type:"wesl3y:mission.trash"}),
    playerBandit = block.dimension.getEntities({ maxDistance: 6, location: {x:x - 27, y: y, z: z + 3}, type: "minecraft:player", tags: ["in_mission"]}).filter(function filterByScore(entity) { return getScore("missions", entity) == 3 || getScore("missions", entity) == 6; }),
    bandit = block.dimension.getEntities({maxDistance:24,location:{x:x - 27, y:y, z:z + 3},type:"wesl3y:mission.bandit"}),
    playerMizuki = block.dimension.getEntities({ maxDistance: 6, location: {x:x + 26, y: y, z: z + 3}, type: "minecraft:player", tags: ["in_mission"]}).filter(function filterByScore(entity) { return getScore("missions", entity) == 10 || getScore("missions", entity) == 13; }),
    mizuki = block.dimension.getEntities({maxDistance:24,location:{x:x + 27, y:y, z:z + 3},type:"wesl3y:mizuki"});
    
  if (entityPlayer.length > 0 && entityTrash.length < 7 && random_trash <= 16) {
    block.dimension.runCommand(`execute if block ${x + ranX} ${y + 1} ${z - ranZ} air run summon wesl3y:mission.trash ${x + ranX} ${y + 1} ${z - ranZ}`);
  }
  if (entityPlayer.length > 0 && entityTrash.length < 7 && random_trash > 16 && random_trash <= 32) {
    block.dimension.runCommand(`execute if block ${x - ranX} ${y + 1} ${z + ranZ} air run summon wesl3y:mission.trash ${x - ranX} ${y + 1} ${z + ranZ}`);
  }
  if (playerBandit.length > 0 && bandit.length < 3) {
    block.dimension.runCommand(`summon wesl3y:mission.bandit ${x - 28} ${y + 1} ${z + 3} ~~ minecraft:entity_spawned`);
    block.dimension.runCommand(`summon wesl3y:mission.bandit ${x - 26} ${y + 1} ${z + 1} ~~ minecraft:entity_spawned`);
    block.dimension.runCommand(`summon wesl3y:mission.bandit ${x - 26} ${y + 1} ${z + 5} ~~ minecraft:entity_spawned`);
  }
  if (playerMizuki.length > 0 && mizuki.length < 1) {
    block.dimension.runCommand(`summon wesl3y:mizuki ${x + 28} ${y + 1} ${z + 3} ~~ minecraft:entity_spawned`);
  }
}

export function mud_despawn_tick(block) {
  const
    on = block.permutation.getState("wesl3y:on"),
    type = block.permutation.getState("wesl3y:type"),
    type2 = block.permutation.getState("wesl3y:type") == "grass_block" ? "grass_block" : block.permutation.getState("wesl3y:type") == "grass_path" ? "grass_path" : "dirt",
    {x,y,z} = block.location;
  if (on == "despawn") {
    block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run fill ${x} ${y} ${z} ${x} ${y} ${z} ${type}`);
  }
  if (on == "placed") {
    block.setPermutation(BlockPermutation.resolve(block.type.id, {"wesl3y:on":"despawn", "wesl3y:type":`${type2}`}));
  }
}

export function itachi_tick_block(block, player) {
  const
    entityPlayer = block.dimension.getEntities({maxDistance:8,location:block.location,type:"minecraft:player"}),
    entityItachi = block.dimension.getEntities({maxDistance:36,location:block.location,type:"wesl3y:itachi_classic"}),
    {x,y,z} = block.location;
  if (entityItachi.length > 0) {
    block.dimension.runCommandAsync(`execute positioned ${x} ${y} ${z} run tp @e[type=wesl3y:itachi_classic,rm=34,r=36,c=1] ${x - 1} ${y + 1.25} ${z + 5}`);
  } else { block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run summon wesl3y:itachi_classic ${x - 0.15} ${y + 1.25} ${z + 5.5} 180 ~ npc`); }
  if (entityPlayer.length > 0 && entityItachi.length > 0) {
    block.dimension.runCommandAsync(`execute positioned ${x} ${y} ${z} run event entity @e[type=wesl3y:itachi_classic,r=11,tag=npc] npc_talk`);
  }
}

export function itachi_tick_block2(block, player) {
  const
    status = block.permutation.getState("wesl3y:status"),
    entityPlayer = block.dimension.getEntities({maxDistance:10,location:block.location,type:"minecraft:player"}),
    entityItachi = block.dimension.getEntities({maxDistance:36,location:block.location,type:"wesl3y:itachi_classic"}),
    {x,y,z} = block.location;
  if (status == "no_spawned") {
    block.dimension.runCommandAsync(`execute positioned ${x} ${y} ${z} run tp @e[type=wesl3y:itachi_classic,rm=34,r=35,c=1] ${x - 1} ${y + 1.25} ${z + 5}`);
    if (entityItachi.length > 0) return;
    block.dimension.runCommand(`execute positioned ${x} ${y} ${z} run summon wesl3y:itachi_classic ${x - 0.2} ${y + 1.25} ${z + 6} 180 ~ npc`);
    block.setPermutation(BlockPermutation.resolve(block.type.id, {"wesl3y:status":"spawned"}));
  } else {
    if (entityPlayer.length > 0) {
      block.dimension.runCommandAsync(`execute positioned ${x} ${y} ${z} run event entity @e[type=wesl3y:itachi_classic,r=11] npc_talk`);
      const blockPerm = BlockPermutation.resolve(block.type.id, {"wesl3y:status":"no_spawned"});
      block.setPermutation(blockPerm);
    }
  }
}

export function chakra_pill(player){
  const vida = player.getComponent("minecraft:health");
  vida?.setCurrentValue(vida?.currentValue + 16);
  if (getScore("chakra", player) < getScore("chakraMax", player)) player.runCommandAsync("scoreboard players add @s chakra 200");
}

export function ramen(player){
  const vida = player.getComponent("minecraft:health");
  vida?.setCurrentValue(vida?.currentValue + 32);
  if (getScore("chakra", player) < getScore("chakraMax", player)) player.runCommandAsync("scoreboard players add @s chakra 20");
}








                
                
                
                
                
                
                
                  
                
                
                        
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                
                
                
                  
                
                
                        
                
                  
                
                
                
                
                
                  
                
                  
                
                
                        
                          
                
                
                
                
                
                  
                
                  
                
                
                        
                            
                              
                  
                
                
                        
                            
                                    
                            
                                                                
                            
                                                   
                
                  
                
                
                
                
                
                  
                
                  
                
                
                        
                          
                
                
                
                
                
                  
                
                  
                
                
                        
                            
                              
                  
                
                
                        
                            
                                    
                            
                                                         
                                              
                        
                          
                
                
                
                
                
                  
                
                  
                
                
                        
                            
                              
                  
                
                
                        
                            
                                    
                            
                                                         
                                                                                          
                                                                                                                                
                                                                                          
                                                                                                                                   
                                                                                                                                                                  
                                                                                                                                                                  
                                                                                                                                                                                                                                                
                                                                                                                                                                  
                                                                                                                                                                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                               
                                                                                                                                                                                                             