import * as mc from '@minecraft/server';
import { getScore, removeScore, shootPower, summonPower } from './all.js';
import * as list from "./list.js";

const activePlayers = new Map();

export async function useJutsus(player, jutsuId, chakraIni) {
  const
    animJuts = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    tickJuts = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakraUse = Math.floor(chakraIni + getScore("jutsu_stats", player) * 3),
    test = list.Powers[jutsuId];
    
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  if (test.requeries) {
    if (!player.hasTag(test.requeries)) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.jutsu"}]}`);
      return;
    }
  }
  if (!test.inWater && player.isInWater) return;
  if (test.inWater && !player.isInWater) return;
  if (test.onGround && !player.isOnGround) return;
  if (getScore("chakra", player) < chakraUse) player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakraUse} chakra"}]}`);
  else if (test.attack) {
    if (player.getDynamicProperty(test.id) != true) {
      removeScore(player, "chakra", chakraUse);
      player.addTag("in_jutsu");
      player.setDynamicProperty(test.id, true);
      // Executa animação do jutsu
      if (test.animation1) player.runCommandAsync(`${test.animation1}`);
      if (test.command1) player.runCommandAsync(`${test.command1}`);
      if (test.command1_2) player.runCommandAsync(`${test.command1_2}`);
      if (test.sound1) player.runCommandAsync(`${test.sound1}`);
      const
        timeout = mc.system.runTimeout(() => { activePlayers.set(player.id, true); }, test.timeUseAttack * 20),
        interval = mc.system.runInterval(() => {
          let inventory = player.getComponent('minecraft:inventory').container;
          let currentItem = inventory.getItem(player.selectedSlotIndex);
          if (!currentItem || currentItem.typeId != test.id) {
            player.setDynamicProperty(test.id, false);
            mc.system.clearRun(timeout);
            mc.system.clearRun(interval);
            activePlayers.delete(player.id);
          }
          if (activePlayers.get(player.id) && !player.hasTag("v_attack")) {
            player.removeTag("in_jutsu");
            if (test.animation2) player.runCommandAsync(`${test.animation2}`);
            if (test.command2) player.runCommandAsync(`${test.command2}`);
            if (test.sound2) player.runCommandAsync(`${test.sound2}`)
          } else if (activePlayers.get(player.id)) {
            if (test.animation3) player.runCommandAsync(`${test.animation3}`);
            if (test.sound3) player.runCommandAsync(`${test.sound3}`);
            if (test.summon1) summonPower(player, test.summon1[0], test.summon1[1], test.summon1[2], test.summon1[3], test.summon1[4], test.name ? player.name : test.nameTag ? player.nameTag : null);
            player.removeTag("in_jutsu");
            player.setDynamicProperty(test.id, false);
            mc.system.clearRun(timeout);
            mc.system.clearRun(interval);
            activePlayers.delete(player.id);
          }
        }, 5);
    }
    player.removeTag("in_jutsu");
  } else {
    removeScore(player, "chakra", chakraUse);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${animJuts} wesl3y`);
    await mc.system.waitTicks(tickJuts);
    if (test.timeUse1) await mc.system.waitTicks(test.timeUse1);
    if (test.animation1) player.runCommandAsync(`${test.animation1}`);
    if (test.sound1) player.runCommandAsync(`${test.sound1}`);
    if (test.shoot1) shootPower(player, test.shoot1[0], test.shoot1[1], test.shoot1[2], test.name ? player.name : test.nameTag ? player.nameTag : null, test.shoot1[3]);
    if (test.summon1) summonPower(player, test.summon1[0], test.summon1[1], test.summon1[2], test.summon1[3], test.summon1[4], test.name ? player.name : test.nameTag ? player.nameTag : null);
    if (test.command1) player.runCommandAsync(`${test.command1}`);
    if (test.command1_2) player.runCommandAsync(`${test.command1_2}`);
    
    if (test.timeUse2) await mc.system.waitTicks(test.timeUse2);
    if (test.animation2) player.runCommandAsync(`${test.animation2}`);
    if (test.sound2) player.runCommandAsync(`${test.sound2}`);
    if (test.shoot2) shootPower(player, test.shoot2[0], test.shoot2[1], test.shoot2[2], test.name ? player.name : test.nameTag ? player.nameTag : null, test.shoot2[3]);
    if (test.summon2) summonPower(player, test.summon2[0], test.summon2[1], test.summon2[2], test.summon2[3], test.summon2[4], test.name ? player.name : test.nameTag ? player.nameTag : null);
    if (test.command2) player.runCommandAsync(`${test.command2}`);
    
    if (test.timeUse3) await mc.system.waitTicks(test.timeUse3);
    if (test.animation3) player.runCommandAsync(`${test.animation3}`);
    if (test.sound3) player.runCommandAsync(`${test.sound3}`);
    if (test.shoot3) shootPower(player, test.shoot3[0], test.shoot3[1], test.shoot3[2], test.name ? player.name : test.nameTag ? player.nameTag : null, test.shoot3[3]);
    if (test.summon3) summonPower(player, test.summon3[0], test.summon3[1], test.summon3[2], test.summon3[3], test.summon3[4], test.name ? player.name : test.nameTag ? player.nameTag : null);
    if (test.command3) player.runCommandAsync(`${test.command3}`);
    
    if (test.timeUse4) await mc.system.waitTicks(test.timeUse4);
    if (test.animation4) player.runCommandAsync(`${test.animation4}`);
    if (test.sound4) player.runCommandAsync(`${test.sound4}`);
    if (test.shoot4) shootPower(player, test.shoot4[0], test.shoot4[1], test.shoot4[2], test.name ? player.name : test.nameTag ? player.nameTag : null, test.shoot4[3]);
    if (test.summon4) summonPower(player, test.summon4[0], test.summon4[1], test.summon4[2], test.summon4[3], test.summon4[4], test.name ? player.name : test.nameTag ? player.nameTag : null);
    if (test.command4) player.runCommandAsync(`${test.command4}`);
    
    if (test.timeUse5) await mc.system.waitTicks(test.timeUse5);
    if (test.animation5) player.runCommandAsync(`${test.animation5}`);
    if (test.sound5) player.runCommandAsync(`${test.sound5}`);
    if (test.shoot5) shootPower(player, test.shoot5[0], test.shoot5[1], test.shoot5[2], test.name ? player.name : test.nameTag ? player.nameTag : null, test.shoot5[3]);
    if (test.summon5) summonPower(player, test.summon5[0], test.summon5[1], test.summon5[2], test.summon5[3], test.summon5[4], test.name ? player.name : test.nameTag ? player.nameTag : null);
    if (test.command5) player.runCommandAsync(`${test.command5}`);
    
    
    player.removeTag("in_jutsu");
  }
}


export async function susanoo1(player) {
  if (getScore("chakra", player) < 100 && player.getProperty('wesl3y:mode_chest') == 0) {
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.requires_chakra_100"}]}`);
  }
  else if (getScore("chakra", player) >= 100 && player.getProperty('wesl3y:mode_chest') == 0) {
    player.runCommand(`playsound susanoo @a ~~~ 0.5`);
    player.runCommand(`event entity @s wesl3y:susanoo1`);
    player.runCommandAsync(`scoreboard players set @s time.Susan 30`);
  }
}

                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                       
                  
                  
                  
                  
                  
                  
                  
                  
                          
                  
                  
                  
                  
                  
                  
                  
                                                                                                                                                                                       
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                       
                  
                  
                  
                  
                  
                  
                  
                  
                          
                  
                  
                  
                  
                  
                  
                  
                                                                                                                                                                                       
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                  
                  
                  
                  
                  
                  
                  
                                                                                                                                                                                       
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
                  
                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            