import * as mc from '@minecraft/server';
import * as ui from '@minecraft/server-ui';
import { addScore, getScore, getItemAmount, random, removeScore, setScore } from './all.js';
import { command } from './events.js';
import * as q from "./list.js";
import { msg_jutsu } from './stats.js';

const Missions = {
  0: "%menu.missions.no_mission\n\n%menu.missions.no_mission2",
  1: "%menu.missions.iruka1\n\n%menu.missions.iruka1_2\n§9%menu.missions.iruka1_3",
  2: "%menu.missions.iruka2\n\n%menu.missions.iruka2_2\n§9%menu.missions.iruka2_3",
  3: "%menu.missions.guy1\n\n%menu.missions.guy1_2\n§9%menu.missions.guy1_3\n§9%menu.missions.guy1_4§0",
  4: "%menu.missions.guy2\n\n%menu.missions.guy2_2\n§9%menu.missions.guy2_3§0",
  5: "%menu.missions.guy3\n\n%menu.missions.guy3_2\n§9%menu.missions.guy3_3§0",
  6: "%menu.missions.guy4\n\n%menu.missions.guy4_2\n§9%menu.missions.guy4_3§0",
  7: "%menu.missions.kakashi1\n\n%menu.missions.kakashi1_2\n§9%menu.missions.kakashi1_2\n§9%menu.missions.kakashi1_4§0",
  8: "%menu.missions.kakashi2\n\n%menu.missions.kakashi2_2\n§9%menu.missions.kakashi2_3§0",
  9: "%menu.missions.kakashi3\n\n%menu.missions.kakashi3_2\n§9%menu.missions.kakashi3_3§0",
  10: "%menu.missions.tsunade1\n\n%menu.missions.tsunade1_2\n§9%menu.missions.tsunade1_2\n§9%menu.missions.tsunade1_4§0",
  11: "%menu.missions.tsunade2\n\n%menu.missions.tsunade2_2\n§9%menu.missions.tsunade2_3§0",
  12: "%menu.missions.tsunade3\n\n%menu.missions.tsunade3_2\n§9%menu.missions.tsunade3_3§0",
  13: "%menu.missions.tsunade4\n\n%menu.missions.tsunade4_2\n§9%menu.missions.tsunade4_3§0",
  30: "%menu.missions.new_clan\n\n%menu.missions.new_clan2\n§9%menu.missions.new_clan2_2§0\n\n%menu.missions.new_clan3\n§9%menu.missions.new_clan3_2§0\n\n%menu.missions.new_clan4\n§9%menu.missions.new_clan4_2§0\n\n%menu.missions.new_clan5\n§9%menu.missions.new_clan5_2§0\n\n%menu.missions.new_clan6\n§9%menu.missions.new_clan6_2§0\n\n%menu.missions.new_clan7\n§9%menu.missions.new_clan7_2§0\n\n%menu.missions.new_clan8\n§9%menu.missions.new_clan8_2§0",
  31: "%menu.missions.byakugan\n\n%menu.missions.byakugan2\n§9%menu.missions.byakugan2_2§0\n\n%menu.missions.byakugan3\n§9%menu.missions.byakugan3_2",
  32: "%menu.missions.sharingan\n\n%menu.missions.sharingan2\n§9%menu.missions.sharingan2_2§0\n\n%menu.missions.sharingan3\n§9%menu.missions.sharingan3_2",
  33: "%menu.missions.mangekyou\n\n%menu.missions.mangekyou2\n§9%menu.missions.mangekyou2_2§0\n\n%menu.missions.mangekyou3\n§9%menu.missions.mangekyou3_2",
  34: "%menu.missions.byakugan\n\n%menu.missions.byakugan2\n§9%menu.missions.byakugan2_2§0\n\n%menu.missions.byakugan3\n§9%menu.missions.byakugan3_2"
}


export async function stats_wait(player) {
  await mc.system.waitTicks(1);
  stats_menu(player);
}

export async function custom_wait(player, menu) {
  await mc.system.waitTicks(1);
  menu(player);
}

export async function clan_wait(player, menu) {
  const
    random1 = random(1, 90),//1, 100
    randomclan = random1 >= 1 && random1 <= 30 ? "hyuga" : random1 >= 31 && random1 <= 50 ? "uchiha" : "uzumaki";
  player.runCommandAsync(`camera @s fade time 0.25 0.25 0.25 color 0 0 0`);
  player.runCommandAsync(`function clan/${randomclan}`);
  await mc.system.waitTicks(10);
  menu(player);
}

export function camera(player) {
  const tick = mc.system.runInterval(() => {
    for (const player of mc.world.getPlayers()) {
      player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
    }
  }, 2);
}

let menu = 0;


export function custom_menu(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomFire");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) return custom_menu(player);
    if (r.selection === 0) {
      custom_menu(player);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_menu(player);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_menu(player);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_menu(player);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu(player);
    }
    if (r.selection === 5) {
      custom_menu(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait(player, custom_menu);
      } else custom_wait(player, custom_menu);
    }
    if (r.selection === 7) {
      custom_menu(player);
    }
    if (r.selection === 8) {
      custom_menu3(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync(`give @s wesl3y:katon_fire_ball 1 0 {"minecraft:keep_on_death":{},"minecraft:item_lock":{"mode":"lock_in_inventory"}}`);
      player.runCommandAsync("camera @s clear");
    }
  }
);}

export function custom_menu2(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomWater");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) player.runCommand("camera @s clear");
    if (r.selection === 0) {
      custom_menu2(player);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_menu2(player);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_menu2(player);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_menu2(player);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu2(player);
    }
    if (r.selection === 5) {
      custom_menu2(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        custom_wait(player, custom_menu2);
      } else custom_wait2(player);
    }
    if (r.selection === 7) {
      custom_menu(player);
    }
    if (r.selection === 8) {
      custom_menu3(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync("give @s wesl3y:suiton_water_dragon");
      player.runCommandAsync("camera @s clear");
    }
  }
);}

export function custom_menu3(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomEarth");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) return custom_menu3(player);
    if (r.selection === 0) {
      custom_menu3(player);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_menu3(player);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_menu3(player);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_menu3(player);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu3(player);
    }
    if (r.selection === 5) {
      custom_menu3(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait(player, custom_menu3);
      } else custom_wait(player, custom_menu3);
    }
    if (r.selection === 7) {
      custom_menu(player);
    }
    if (r.selection === 8) {
      custom_menu3(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync(`give @s wesl3y:doton_earth_spears 1 0 {"minecraft:keep_on_death":{},"minecraft:item_lock":{"mode":"lock_in_inventory"}}`);
      player.runCommandAsync(`camera @s clear`);
    }
  }
);}

export function custom_menu4(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomLightning");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) player.runCommand("camera @s clear");
    if (r.selection === 0) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu4(player);
    }
    if (r.selection === 5) {
      custom_menu4(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait4(player);
      } else custom_wait(player, custom_menu4);
    }
    if (r.selection === 7) {
      custom_menu3(player);
    }
    if (r.selection === 8) {
      custom_menu5(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync("give @s wesl3y:raiton_gian");
    }
  }
);}

export function custom_menu5(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomFuuton");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) player.runCommand("camera @s clear");
    if (r.selection === 0) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu5(player);
    }
    if (r.selection === 5) {
      custom_menu5(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait5(player);
      } else custom_wait(player, custom_menu5);
    }
    if (r.selection === 7) {
      custom_menu4(player);
    }
    if (r.selection === 8) {
      custom_menu5(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync("give @s wesl3y:raiton_gian");
    }
  }
);}

let quantity = 1;
export async function stats_menu(player) {
  const form = new ui.ActionFormData();
  const
    mentor = player.hasTag("guy_mentor") ? "§aGai" : player.hasTag("kakashi_mentor") ? "§aKakashi" : "§c%palavra.nenhum",
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("senju") ? "Senju" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("uzumaki") ? "Uzumaki" : null,
    chkScore = getScore("chakra_stats", player),
    chkMax = Math.floor(100 + 40 * getScore("chakra_stats", player)),
    chk0 = getScore("chakra_stats", player) < 10 ? "00" : getScore("chakra_stats", player) < 100 ? "0": "",
    dmgScore = getScore("damage_stats", player),
    dmgMax = Math.floor(1 + 0.2 * getScore("damage_stats", player)),
    dmg0 = getScore("damage_stats", player) < 10 ? "00" : getScore("damage_stats", player) < 100 ? "0": "",
    hpScore = getScore("health_stats", player),
    hpMax = Math.floor(20 + 15 * getScore("health_stats", player)),
    hp0 = getScore("health_stats", player) < 10 ? "00" : getScore("health_stats", player) < 100 ? "0" : "",
    jtsScore = getScore("jutsu_stats", player),
    jts0 = getScore("jutsu_stats", player) < 10 ? "00" : getScore("jutsu_stats", player) < 100 ? "0" : "",
    wpnScore = getScore("weapons_stats", player),
    wpn0 = getScore("weapons_stats", player) < 10 ? "00" : getScore("weapons_stats", player) < 100 ? "0" : "",
    tpScore = getScore(`tp`, player);
  form.title("Stats");
  form.body(`Tp: §9${tpScore}§0\nPlayer: §9${clan} ${player.name}§0\nMentor: ${mentor}§0\n\n   Chakra: §9${chk0}${chkScore}/200§0                      Max: §9${chkMax}§0\n\n   Damage: §9${dmg0}${dmgScore}/200§0                     Max: §9${dmgMax}§0\n\n   Health: §9${hp0}${hpScore}/200§0                      Max: §9${hpMax}§0\n\n   Jutsu: §9${jts0}${jtsScore}/200§0\n                                                                                                               Cost: §9${5 * quantity} Tp§0\n   Weapon: §cNext Version§0                                                      Quantity: §9${quantity}§0`);
  form.button("§e+");
  form.button("§e+");
  form.button("§e+");
  form.button("§e+");
  form.button("§e+");
  form.button("§e-");
  form.button("§e+");
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.show(player).then((r) => {
    player.removeTag("stats_menu");
    if (r.selection === 0) {
      if (getScore("chakra_stats", player) < (201 - quantity)) {
        if (getScore("tp", player) >= (5 * quantity)) {
          addScore(player, "chakra_stats", 1 * quantity)
          removeScore(player, "tp", 5 * quantity)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 1) {
      if (getScore("damage_stats", player) < (201 - quantity)) {
        if (getScore("tp", player) >= (5 * quantity)) {
          addScore(player, "damage_stats", 1 * quantity)
          removeScore(player, "tp", 5 * quantity)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 2) {
      if (getScore("health_stats", player) < (201 - quantity)) {
        if (getScore("tp", player) >= (5 * quantity)) {
          addScore(player, "health_stats", 1 * quantity)
          removeScore(player, "tp", 5 * quantity)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 3) {
      if (getScore("jutsu_stats", player) < (201 - quantity)) {
        if (getScore("tp", player) >= (5 * quantity)) {
          addScore(player, "jutsu_stats", 1 * quantity)
          removeScore(player, "tp", 5 * quantity)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          msg_jutsu(player);
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 4) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"text": "§cNext Version\nPróxima Versão"}]}`);
    }
    if (r.selection === 5) {
      if (quantity != 1) {
        quantity = quantity == 5 ? quantity - 4 : quantity != 1 ? quantity - 5 : 1;
        stats_wait(player);
      } else stats_wait(player);
    }
    if (r.selection === 6) {
      if (quantity != 20) {
        quantity = quantity == 1 ? quantity + 4 : quantity != 20 ? quantity + 5 : 20;
        stats_wait(player);
      } else stats_wait(player);
    }
    if (r.selection === 7) {
      stats_wait(player);
    }
    if (r.selection === 8) {
      stats_missions(player);
    }
    if (r.selection === 9) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "§cNext Version"}]}`);
      //stats_wait(player);
    }
    if (r.selection === 10) {
      stats_skills(player);
    }
    if (r.selection === 11) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "§cNext Version"}]}`);
      //stats_skills_clan(player);
    }
  }
);}

export function stats_missions(player) {
  const
    form = new ui.ActionFormData(),
    tagMsn = player.hasTag("in_mission") ? Missions[getScore("missions", player)] : "%menu.missions.no_mission\n\n\n%menu.missions.no_mission2";
  form.title(`Mission`);
  form.body(`${tagMsn}`);
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      stats_menu(player);
    }
    if (r.selection === 1) {
      stats_missions(player);
    }
    if (r.selection === 2) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "§cNext Version"}]}`);
    }
  }
);}

export function stats_skills(player) {
  const
    form = new ui.ActionFormData(),
    ying_yang = !player.hasTag('unlock.ying_yang') ? "Lock:" : "",
    fire1 = !player.hasTag('unlock.fire1') ? "Lock:" : "",
    fire2 = !player.hasTag('unlock.fire2') ? "Lock:" : "",
    fire3 = !player.hasTag('unlock.fire3') ? "Lock:" : "",
    fire4 = !player.hasTag('unlock.fire4') ? "Lock:" : "",
    earth1 = !player.hasTag('unlock.earth1') ? "Lock:" : "",
    earth2 = !player.hasTag('unlock.earth2') ? "Lock:" : "",
    earth3 = !player.hasTag('unlock.earth3') ? "Lock:" : "",
    earth4 = !player.hasTag('unlock.earth4') ? "Lock:" : "",
    earthItem = getItemAmount(player, "wesl3y:doton_earth_spears") || getItemAmount(player, "wesl3y:doton_earth_wall") || getItemAmount(player, "wesl3y:doton_earth_golem") || getItemAmount(player, "wesl3y:doton_underworld_swamp"),
    fireItem = getItemAmount(player, "wesl3y:katon_fire_ball") || getItemAmount(player, "wesl3y:katon_phoenix_flower") || getItemAmount(player, "wesl3y:katon_explosive_clone") || getItemAmount(player, "wesl3y:katon_fire_dragon");
  form.title(`Skills`);
  form.body(``);
  form.button(`§g${ying_yang} Ying Yang\n§9Cost: 10 Tp`);//Ying Yang
  form.button(`§g${fire1} Fire Ball\n§9Katon Rank C\nCost: 14 Tp\nRequeries: Chakra 3`);//Katon
  form.button(`§g${earth1} Earth Spears\n§9Doton Rank B\nCost: 26 Tp\nRequeries: Chakra 8`);//Doton
  form.button(`Lock`);//Lock Fuuton
  form.button(`§g${fire2} Phoenix Flower\n§9Katon Rank C\nCost: 21 Tp\nRequeries: Chakra 7`);//Katon 2
  form.button(`§g${earth2} Earth Wall\n§9Doton Rank B\nCost: 21 Tp\nRequeries: Chakra 5`);//Doton 2
  form.button(`Lock`);//Lock Fuuton 2
  form.button(`§g${fire3} Explosive Clone\n§9Katon Rank B\nCost: 31 Tp\nRequeries: Chakra 10`);//Katon 3
  form.button(`§g${earth3} Earth Golem\n§9Doton Rank C\nCost: 21 Tp\nRequeries: Chakra 7`);//Doton 3
  form.button(`Lock`);//Lock Fuuton 3
  form.button(`§g${fire4} Fire Dragon\n§9Katon Rank B\nCost: 41 Tp\nRequeries: Chakra 15`);//Katon 4
  form.button(`§g${earth4} Underworld Swamp\n§9Doton Rank A\nCost: 65 Tp\nRequeries: Chakra 30`);//Doton 4
  form.button(`Lock`);//Lock Fuuton 4
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("tp", player) >= 10 && !player.hasTag("unlock.ying_yang")) {
        player.addTag("unlock.ying_yang");
        stats_skills(player);
      } else if (player.hasTag("unlock.ying_yang")) stats_skills(player);
      else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
    }
    if (r.selection === 1) {
      if (getScore("chakra_stats", player) >= 3 && getScore("tp", player) >= 14 && fireItem > 0 && player.hasTag("unlock.ying_yang") && !player.hasTag("unlock.fire1")) {
        player.addTag("unlock.fire1");
        removeScore(player, "tp", 4);
        stats_skills(player);
      } else if (player.hasTag("unlock.fire1")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 3) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 3 chakra stats"}]}`);
      } else if (getScore("tp", player) < 14) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (fireItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleFire"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.ying_yang"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 2) {
      if (getScore("chakra_stats", player) >= 8 && getScore("tp", player) >= 26 && earthItem > 0 && player.hasTag("unlock.ying_yang") && !player.hasTag("unlock.earth1")) {
        player.addTag("unlock.earth1");
        removeScore(player, "tp", 26);
        stats_skills(player);
      } else if (player.hasTag("unlock.earth1")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 8) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 8 chakra stats"}]}`);
      } else if (getScore("tp", player) < 26) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (earthItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleEarth"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.ying_yang"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 3) {
      stats_skills(player);
    }
    if (r.selection === 4) {
      if (getScore("chakra_stats", player) >= 7 && getScore("tp", player) >= 21 && fireItem > 0 && player.hasTag("unlock.fire1") && !player.hasTag("unlock.fire2")) {
        player.addTag("unlock.fire2");
        removeScore(player, "tp", 4);
        stats_skills(player);
      } else if (player.hasTag("unlock.fire2")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 7) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 7 chakra stats"}]}`);
      } else if (getScore("tp", player) < 21) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (fireItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleFire"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.back_jutsu"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 5) {
      if (getScore("chakra_stats", player) >= 5 && getScore("tp", player) >= 21 && earthItem > 0 && player.hasTag("unlock.earth1") && !player.hasTag("unlock.earth2")) {
        player.addTag("unlock.earth2");
        removeScore(player, "tp", 21);
        stats_skills(player);
      } else if (player.hasTag("unlock.earth2")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 5) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 5 chakra stats"}]}`);
      } else if (getScore("tp", player) < 21) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (earthItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleEarth"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.back_jutsu"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 6) {
      stats_skills(player);
    }
    if (r.selection === 7) {
      if (getScore("chakra_stats", player) >= 10 && getScore("tp", player) >= 31 && fireItem > 0 && player.hasTag("unlock.fire2") && !player.hasTag("unlock.fire3")) {
        player.addTag("unlock.fire3");
        removeScore(player, "tp", 31);
        stats_skills(player);
      } else if (player.hasTag("unlock.fire3")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 10) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 10 chakra stats"}]}`);
      } else if (getScore("tp", player) < 31) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (fireItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleFire"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.back_jutsu"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 8) {
      if (getScore("chakra_stats", player) >= 7 && getScore("tp", player) >= 21 && earthItem > 0 && player.hasTag("unlock.earth2") && !player.hasTag("unlock.earth3")) {
        player.addTag("unlock.earth3");
        removeScore(player, "tp", 21);
        stats_skills(player);
      } else if (player.hasTag("unlock.earth3")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 7) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 7 chakra stats"}]}`);
      } else if (getScore("tp", player) < 21) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (earthItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleEarth"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.back_jutsu"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 9) {
      stats_skills(player);
    }
    if (r.selection === 10) {
      if (getScore("chakra_stats", player) >= 15 && getScore("tp", player) >= 41 && fireItem > 0 && player.hasTag("unlock.fire3") && !player.hasTag("unlock.fire4")) {
        player.addTag("unlock.fire4");
        removeScore(player, "tp", 41);
        stats_skills(player);
      } else if (player.hasTag("unlock.fire4")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 15) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 15 chakra stats"}]}`);
      } else if (getScore("tp", player) < 41) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (fireItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleFire"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.back_jutsu"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 11) {
      if (getScore("chakra_stats", player) >= 30 && getScore("tp", player) >= 65 && earthItem > 0 && player.hasTag("unlock.earth3") && !player.hasTag("unlock.earth4")) {
        player.addTag("unlock.earth4");
        removeScore(player, "tp", 65);
        stats_skills(player);
      } else if (player.hasTag("unlock.earth4")) stats_skills(player);
        else if (getScore("chakra_stats", player) < 30) {
        player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires 30 chakra stats"}]}`);
      } else if (getScore("tp", player) < 65) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"up.no_tp"},{"text":"§f"}]}`);
      } else if (earthItem == 0) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.styleEarth"},{"text":"§f"}]}`);
      } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.back_jutsu"},{"text":"§f"}]}`);
      }
    }
    if (r.selection === 12) {
      stats_skills(player);
    }
    if (r.selection === 13) {
      stats_menu(player);
    }
    if (r.selection === 14) {
      stats_missions(player);
    }
    if (r.selection === 15) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "§cNext Version"}]}`);
      //stats_menu(player);
    }
    if (r.selection === 16) {
      stats_skills(player);
    }
    if (r.selection === 17) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "§cNext Version"}]}`);
      //stats_skills_clan(player);
    }
  }
);}





export function npc_ichiraku(player) {
  const form = new ui.ActionFormData();
  form.title("NpcShop");
  form.body("§c[Ichiraku] - §f%npc.ichiraku\n\n§c[Ichiraku] - §f%npc.oque_deseja");
  form.button("50R$ = 1x Rámen");
  form.button("200R$ = 1x Chakra Pill");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("money", player) >= 50) {
        player.runCommandAsync("give @s wesl3y:ramen");
        removeScore(player, "money", 50);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 1) {
      if (getScore("money", player) >= 200) {
        player.runCommandAsync("give @s wesl3y:chakra_pill");
        removeScore(player, "money", 200);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
  }
);}

export function npc_iruka0(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Iruka] - §f%npc.iruka0");
  form.button("Yes");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("level", player) >= 5) {
        player.runCommandAsync(`give @s wesl3y:kunai`);
        player.runCommandAsync(`give @s wesl3y:suit_bandana`);
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "unlock.gennin"}]}`);
        player.addTag("gennin");
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "5"}]}`);
    }
  }
);}

export function npc_iruka(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Iruka] - §f%npc.oque_deseja");
  form.button("Missions");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      npc_iruka_miss(player);
    }
  }
);}

export function npc_iruka_miss(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Iruka] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.iruka1");
  form.button("Trash");
  form.button("Clone");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 1 && getScore("level", player) <= 15) {
          setScore(player, "missions", 1);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "1..15§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 5 && getScore("level", player) <= 15) {
          setScore(player, "missions", 2);
          player.addTag("start_mission");
          player.runCommandAsync(`summon wesl3y:mission.iruka_clone ~~~1 ~~ minecraft:entity_spawned`);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "5..15§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
  }
);}

export function npc_guy(player) {
  const form = new ui.ActionFormData();
  form.title("Npc1");
  form.body("§c[Guy] - §f%npc.oque_deseja");
  form.button("Mentor");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("guy_mentor") && !player.hasTag("kakashi_mentor") && !player.hasTag("tsunade_mentor")) {
        npc_guy_no_mentor(player);
      } else if (player.hasTag("guy_mentor")) npc_guy_mentor(player); else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"you.already_mentor"}]}`);
    }
  }
);}

export function npc_guy_no_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Guy] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.guy1\n\n§c[Guy] - §f%npc.guy1_2");
  form.button("Ok");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.addTag("guy_mentor");
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"choose.mentor.guy\"}]}");
    }
    if (r.selection === 1) {
      npc_kakashi(player);
    }
  }
);}

export function npc_guy_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc4");
  form.body("§c[Guy] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.guy1_3\n\n§c[Guy] - §f%npc.guy1_4");
  form.button("Rank C");
  form.button("Rank B");
  form.button("Rank A");
  form.button("Eight Gates");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 10 && getScore("level", player) <= 35) {
          setScore(player, "missions", 3);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "10..35§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 30 && getScore("level", player) <= 65) {
          setScore(player, "missions", 4);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "30..65§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 2) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "§cNext Version"}]}`);
    }
    if (r.selection == 3) {
      npc_guy_gates(player);
    }
  }
);}

export function npc_guy_gates(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Guy] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.guy1_3\n\n§c[Guy] - §f%npc.guy1_4\n\n§a[Você] - §f%npc.guy1_5\n\n§c[Guy] - §f%npc.guy1_6");
  form.button("Yes");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("level", player) >= 30) {
        if (!player.hasTag("unlock.gates")) {
          setScore(player, "missions", 6);
          player.addTag("start_mission");
          command(player, 30, "tag @s add finish_mission", "tag @s add unlock.gates");
          player.runCommandAsync(`summon wesl3y:guy ~~~1 ~~ mission`);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"you.already"}, {"translate":" Eight Gates"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"mission.requires_level"}, {"translate":"30"}]}`);
    }
  }
);}

export function npc_kakashi(player) {
  const form = new ui.ActionFormData();
  form.title("Npc1");
  form.body("§c[Kakashi] - §f%npc.oque_deseja");
  form.button("Mentor");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("guy_mentor") && !player.hasTag("kakashi_mentor") && !player.hasTag("tsunade_mentor")) {
        npc_kakashi_no_mentor(player);
      } else if (player.hasTag("kakashi_mentor")) npc_kakashi_mentor(player); else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"you.already_mentor"}]}`);
    }
  }
);}

export function npc_kakashi_no_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Kakashi] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.kakashi1\n\n§c[Kakashi] - §f%npc.kakashi1_2");
  form.button("Ok");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.addTag("kakashi_mentor");
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"choose.mentor.kakashi\"}]}");
    }
    if (r.selection === 1) {
      npc_kakashi(player);
    }
  }
);}

export function npc_kakashi_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc3");
  form.body("§c[Kakashi] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.kakashi1_3\n\n§c[Kakashi] - §f%npc.kakashi1_4");
  form.button("Rank C");
  form.button("Rank B");
  form.button("Rank A");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 10 && getScore("level", player) <= 35) {
          setScore(player, "missions", 7);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "10..35§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 30 && getScore("level", player) <= 65) {
          setScore(player, "missions", 8);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "30..65§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 2) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 60) {
          setScore(player, "missions", 9);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "60§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
  }
);}

export function npc_shinobi(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Shinobi] - §f%npc.shinobi\n\n§c[Shinobi] - §f%npc.shinobi2\n\n§c[Shinobi] - §f%npc.shinobi3");
  form.button("Trash");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("scoreboard players add @s[hasitem={item=wesl3y:trash_item,quantity=1..}] money 30");
      player.runCommandAsync("scoreboard players add @s[hasitem={item=wesl3y:trash_item,quantity=1..}] exp 5");
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:trash_item,quantity=1..}] {"rawtext":[{"text":"Thanks!"}]}`);
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:trash_item,quantity=1..}] wesl3y:trash_item 0 1");
    }
    if (r.selection === 1) {}
  }
);}

export function npc_tenten(player) {
  const form = new ui.ActionFormData();
  form.title("NpcShop6");
  form.body("§c[Tenten] - §f%npc.tenten\n\n§c[Tenten] - §f%npc.oque_deseja");
  form.button("400R$ = 1x Kunai");
  form.button("500R$ = 1x Kunai Asuma");
  form.button("2500R$ = 1x Kusanagi");
  form.button("5000R$ = 1x Kubikiribocho");
  form.button("1500R$ = 1x Gunbai");
  form.button("5000R$ = 1x Scythe");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("money", player) >= 400) {
        player.runCommandAsync("give @s wesl3y:kunai");
        removeScore(player, "money", 400);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 1) {
      if (getScore("money", player) >= 500) {
        player.runCommandAsync("give @s wesl3y:kunai_asuma");
        removeScore(player, "money", 500);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 2) {
      if (getScore("money", player) >= 2500) {
        player.runCommandAsync("give @s wesl3y:kusanagi");
        removeScore(player, "money", 2500);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 3) {
      if (getScore("money", player) >= 5000) {
        player.runCommandAsync("give @s wesl3y:kubikiribocho");
        removeScore(player, "money", 5000);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 4) {
      if (getScore("money", player) >= 1500) {
        player.runCommandAsync("give @s wesl3y:gunbai");
        removeScore(player, "money", 1500);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 5) {
      if (getScore("money", player) >= 5000) {
        player.runCommandAsync("give @s wesl3y:scythe");
        removeScore(player, "money", 5000);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
  }
);}

export function npc_tsunade(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Tsunade] - §f%npc.oque_deseja");
  form.button("Mission");
  form.button("Mentor");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      npc_tsunade1(player);
    }
    if (r.selection === 1) {
      if (!player.hasTag("guy_mentor") && !player.hasTag("kakashi_mentor") && !player.hasTag("tsunade_mentor")) {
        npc_tsunade_no_mentor(player);
      } else if (player.hasTag("tsunade_mentor")) npc_tsunade_mentor(player); else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"you.already_mentor"}]}`);
    }
  }
);}

export function npc_tsunade1(player) {
  const form = new ui.ActionFormData();
  form.title("Npc3");
  form.body("§c[Tsunade] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.tsunade1\n\n§c[Tsunade] - §f%npc.tsunade1_2");
  form.button("Rank C");
  form.button("Rank A");
  form.button("Rank S");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 10 && getScore("level", player) <= 35) {
          setScore(player, "missions", 10);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "10..35"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 30 && getScore("level", player) <= 80) {
          setScore(player, "missions", 11);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "30..80§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 2) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 80) {
          setScore(player, "missions", 12);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "80§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
  }
);}

export function npc_tsunade_no_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Tsunade] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.tsunade1_3\n\n§c[Tsunade] - §f%npc.tsunade1_4");
  form.button("Ok");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.addTag("tsunade_mentor");
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"choose.mentor.tsunade\"}]}");
    }
    if (r.selection === 1) {
      npc_tsunade(player);
    }
  }
);}

export function npc_tsunade_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Tsunade] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.tsunade1_5\n\n§c[Tsunade] - §f%npc.tsunade1_6");
  form.button("Yes");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("unlock.palmCure")) {
        setScore(player, "missions", 13);
        player.addTag("start_mission");
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "you.already"},{"translate": " Jutsu Palm Cure"}]}`);
    }
    if (r.selection === 1) {
      npc_tsunade(player);
    }
  }
);}

export function npc_velha(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Random] - §f%npc.velha");
  form.button("Cake");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("scoreboard players add @s[hasitem={item=cake,quantity=1..}] exp 15");
      player.runCommandAsync("clear @s cake 0 1");
      player.runCommandAsync(`tellraw @s[hasitem={item=cake,quantity=1..}] {"rawtext":[{"text":"Thanks!"}]}`);
    }
    if (r.selection === 1) {}
  }
);}
                              
          
          
          
          
          
          
          
          
          
                    
                         
          
          
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                                                              
                              
                              
                              
                              
                              
                                                                                                                            
                              
                                                                                                        
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                                                              
                              
                              
                              
                              
                              
                                                                                                                            
                              
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            