import * as mc from "@minecraft/server";
import * as q from "./list.js";
import { addScore, getScore, getItemAmount, random, removeScore, setScore } from './all.js';

mc.world.afterEvents.playerSpawn.subscribe((data) => {
  const
    { player } = data;
    
  player.removeTag("camera.haku");
});

const activePlayers = new Map();

mc.world.afterEvents.playerSpawn.subscribe((data) => {
  const
    { player } = data,
    mission = q.Missions.list[getScore("missions", player)];
  
  if (player.hasTag("in_mission")) {
    player.runCommandAsync("tag @s remove finish_mission");
    player.runCommandAsync("tag @s remove in_mission");
    player.runCommandAsync(`tellraw @s {"rawtext":[{"text": "§e<"},{"translate": "mission.failed"},{"text": ">\n§f"}]}`);
    setScore(player, "missions", 0);
  }
  
  player.removeTag("camera.haku");
  
  if (player.getDynamicProperty('wesl3y:rasengan')) player.setDynamicProperty('wesl3y:rasengan', false);
  activePlayers.delete(player.id);
  
  player.removeTag("in_jutsu");
  
  if (player.getProperty("wesl3y:mode_chest") == 10) {
    player.triggerEvent("wesl3y:reset_chest");
    player.runCommandAsync(`scoreboard players remove @s[scores={level=6..}] level 5`);
    player.runCommandAsync(`kill @s`);
  }
  
  if (player.getProperty('wesl3y:mode_chest') == 13) {
    player.triggerEvent("wesl3y:reset_chest");
    player.runCommandAsync(`effect @s wither 10 2 true`);
    player.runCommandAsync(`effect @s blindness 7 2 true`);
    player.runCommandAsync(`effect @s weakness 7 2 true`);
  }
});