import * as mc from '@minecraft/server';
import { getScore } from './all.js';

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    const
      hp = player.getComponent("health"),
      
      chkSc = getScore("chakra", player),
      chkMaxSc = getScore("chakraMax", player),
      expSc = getScore("exp", player),
      expMaxSc = getScore("expMax", player),
      hpStSc = getScore("health_stats", player),
      
      chkMax = Math.floor(100 + 40 * getScore("chakra_stats", player)),
      dmgMax = Math.floor(1 + 0,2 * getScore("damage_stats", player)),
      expMax = Math.floor(getScore("level", player) * 100 + (getScore("level", player) - 1) * 30),
      hpMax = Math.floor(20 + 15 * getScore("health_stats", player)),
      dano = Math.floor(1 + getScore("damage_stats1", player) + 0.2 * getScore("damage_stats", player));
    if (getScore("stun", player) > 0) {
      player.triggerEvent(`damage.0`);
    } else player.triggerEvent(`damage.` + `${dano}`);
    if (chkSc > chkMaxSc) {
      player.runCommandAsync(`scoreboard players set @s chakra ${chkMax}`);
      //player.runCommandAsync(`say test: ${chkSc}/${chkMax}`);
    }
    if (chkMaxSc != chkMax) {
      player.runCommandAsync(`scoreboard players set @s chakraMax ${chkMax}`);
      //player.runCommandAsync(`say test0: ${chkMax}`);
    }
    if (expSc > expMax) {
      if (hp.currentValue < hp.defaultValue / 2) { hp.setCurrentValue = hp.defaultValue / 2 }
      player.runCommandAsync(`playsound random.levelup @s ~~~ 10 1 10`);
      player.runCommandAsync(`scoreboard players add @s level 1`);
      player.runCommandAsync(`scoreboard players add @s tp 5`);
      player.runCommandAsync(`tellraw @s {"rawtext": [{"text": "§a"},{"translate": "%up.level"},{"text": "\n +5 Tp§f"}]}`);
      player.runCommandAsync(`scoreboard players remove @s exp ${expMaxSc}`);
      msg_level(player);
    }
    if (expMaxSc != expMax) {
      player.runCommandAsync(`scoreboard players set @s expMax ${expMax}`);
      //player.runCommandAsync(`say test028: ${expMax}`);
    }
    if (hp.defaultValue != hpMax) {
      player.runCommandAsync(`event entity @s health.${hpStSc}`);
      //player.runCommandAsync(`say test3: ${hpMax}`);
    }
  }
}, 0.1);

//effectiveMax,currentValue,setCurrentValue,defaultValue

export function msg_level(player) {
  const
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("senju") ? "Senju" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("uzumaki") ? "Uzumaki" : null;
  switch (clan) {
    case `Hyuga`:
      if (getScore("level", player) == 5) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.dash"}]}`);
      }
      if (getScore("level", player) >= 10 && !player.hasTag("unlock.bya")) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.byakugan"}]}`);
        player.addTag("unlock.bya");
      }
      if (getScore("level", player) == 20) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.byakugan.trigramas"}]}`);
      if (getScore("level", player) == 50) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.byakugan.leos_gemeos"}]}`);
    break
    case `Uchiha`:
      if (getScore("level", player) == 5) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.dash"}]}`);
      if (getScore("level", player) >= 20 && !player.hasTag("unlock.sha")) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.sharingan"}]}`);
        player.addTag("unlock.sha");
      }
      if (getScore("level", player) == 30) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.sharingan.genjutsu"}]}`);
      if (getScore("level", player) == 50) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.sharingan"}]}`);
      if ((getScore("level", player) >= 90 && !player.hasTag("unlock.mang"))) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.mangekyou"}]}`);
        player.addTag("unlock.mang");
      }
      if (getScore("level", player) == 120) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.mangekyou.amaterasu"}]}`);
      if (getScore("level", player) == 100) player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.mangekyou.susanoo"}]}`);
    break
  }
}

export function msg_jutsu(player) {
  const
    jutsu = getScore("jutsu_stats", player) == 29 ? "30" : getScore("jutsu_stats", player) == 59 ? "60" : getScore("jutsu_stats", player) == 89 ? "90" : getScore("jutsu_stats", player) == 119 ? "120" : "";
  switch (jutsu) {
    case `30`:
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.jutsu30"}]}`);
    break
    case `60`:
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.jutsu60"}]}`);
    break
    case `90`:
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.jutsu90"}]}`);
    break
    case `120`:
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"unlock.jutsu120"}]}`);
    break
  }
}
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             