import * as mc from "@minecraft/server";

function generateStructure(player, x, y, z, radius, timer, dynamicProperty, structureName, message) {
  const distance = Math.sqrt(Math.pow(player.location.x - x, 2) + Math.pow(player.location.z - z, 2));
  const propertyValue = mc.world.getDynamicProperty(dynamicProperty);

  if (propertyValue != 1 && distance <= radius && player.isOnGround && !player.isInWater) {
    mc.world.setDynamicProperty(dynamicProperty, 1);
    player.runCommandAsync(`structure load mystructure:${structureName} ${x - 32} ${y} ${z - 32} 0_degrees none layer_by_layer ${timer}`);
    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§c${message}"}]}`);
  }
}

function generateMob(player, x, y, z, radius, cutscene, idmob, idmob2) {
  const distance = Math.sqrt(Math.pow(player.location.x - x, 2) + Math.pow(player.location.z - z, 2));
  const mobCurrent = player.dimension.getEntities({maxDistance:36,location: {x: x, y: y, z: z},type: idmob});
  const mobCurrent2 = player.dimension.getEntities({maxDistance:36,location: {x: x, y: y, z: z},type: idmob2});
  if (!idmob2 && mobCurrent < 1 && distance <= radius && player.isOnGround && !player.isInWater) {
    player.runCommandAsync(`summon ${idmob} ${x} ${y + 2} ${z} ~ ~ minecraft:entity_spawned`);
  } else if (mobCurrent < 1 && mobCurrent2 < 1 && distance <= radius && player.isOnGround && !player.isInWater) {
    player.runCommandAsync(`summon ${idmob} ${x} ${y + 2} ${z} ~ ~ minecraft:entity_spawned`);
  }
}

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    generateStructure(player, -450, Math.floor(player.location.y - 2), 760, 10, 20, "wesl3y:itachi", "itachi_hideout", "Generating Itachi Hideout...");
    generateStructure(player, Math.floor(player.location.x), Math.floor(player.location.y - 2), Math.floor(player.location.z), 6, 0, "wesl3y:konoha", "konoha", "Generating Konoha...");
    generateMob(player, -200, Math.floor(player.location.y), 150, 5, "gaara", "wesl3y:gaara_classic");
    generateMob(player, 20, Math.floor(player.location.y), 200, 5, "anbu", "wesl3y:mission.anbu");
    generateMob(player, 300, Math.floor(player.location.y), -45, 5, "mizuki", "wesl3y:mizuki");
    generateMob(player, 100, Math.floor(player.location.y), 450, 5, "sasuke", "wesl3y:sasuke_classic");
    generateMob(player, -20, Math.floor(player.location.y), -350, 5, "zabuza", "wesl3y:haku", "wesl3y:zabuza");
  }
}, 400);
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                                                               
                                        
                                        
                                                                                                            
                                                                                         
                                        
                                        
                                        
                                        
                                                                                                                                                               
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                                                               
                                        
                                        
                                                                                                            
                                                                                         
                                        
                                        
                                        
                                        
                                                                                                                                                                                                   
                                                                                         
                                        
                                        
                                        
                                        
                                                                                                                                                                                              